#coding: latin-1

#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.

##		    GNU GENERAL PUBLIC LICENSE
##		       Version 2, June 1991

## Copyright (C) 1989, 1991 Free Software Foundation, Inc.
##                       59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
## Everyone is permitted to copy and distribute verbatim copies
## of this license document, but changing it is not allowed.

##			    Preamble

##  The licenses for most software are designed to take away your
##freedom to share and change it.  By contrast, the GNU General Public
##License is intended to guarantee your freedom to share and change free
##software--to make sure the software is free for all its users.  This
##General Public License applies to most of the Free Software
##Foundation's software and to any other program whose authors commit to
##using it.  (Some other Free Software Foundation software is covered by
##the GNU Library General Public License instead.)  You can apply it to
##your programs, too.

##  When we speak of free software, we are referring to freedom, not
##price.  Our General Public Licenses are designed to make sure that you
##have the freedom to distribute copies of free software (and charge for
##this service if you wish), that you receive source code or can get it
##if you want it, that you can change the software or use pieces of it
##in new free programs; and that you know you can do these things.

##  To protect your rights, we need to make restrictions that forbid
##anyone to deny you these rights or to ask you to surrender the rights.
##These restrictions translate to certain responsibilities for you if you
##distribute copies of the software, or if you modify it.

##  For example, if you distribute copies of such a program, whether
##gratis or for a fee, you must give the recipients all the rights that
##you have.  You must make sure that they, too, receive or can get the
##source code.  And you must show them these terms so they know their
##rights.

##  We protect your rights with two steps: (1) copyright the software, and
##(2) offer you this license which gives you legal permission to copy,
##distribute and/or modify the software.

##  Also, for each author's protection and ours, we want to make certain
##that everyone understands that there is no warranty for this free
##software.  If the software is modified by someone else and passed on, we
##want its recipients to know that what they have is not the original, so
##that any problems introduced by others will not reflect on the original
##authors' reputations.

##  Finally, any free program is threatened constantly by software
##patents.  We wish to avoid the danger that redistributors of a free
##program will individually obtain patent licenses, in effect making the
##program proprietary.  To prevent this, we have made it clear that any
##patent must be licensed for everyone's free use or not licensed at all.

##  The precise terms and conditions for copying, distribution and
##modification follow.
##
##		    GNU GENERAL PUBLIC LICENSE
##   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

##  0. This License applies to any program or other work which contains
##a notice placed by the copyright holder saying it may be distributed
##under the terms of this General Public License.  The "Program", below,
##refers to any such program or work, and a "work based on the Program"
##means either the Program or any derivative work under copyright law:
##that is to say, a work containing the Program or a portion of it,
##either verbatim or with modifications and/or translated into another
##language.  (Hereinafter, translation is included without limitation in
##the term "modification".)  Each licensee is addressed as "you".

##Activities other than copying, distribution and modification are not
##covered by this License; they are outside its scope.  The act of
##running the Program is not restricted, and the output from the Program
##is covered only if its contents constitute a work based on the
##Program (independent of having been made by running the Program).
##Whether that is true depends on what the Program does.

##  1. You may copy and distribute verbatim copies of the Program's
##source code as you receive it, in any medium, provided that you
##conspicuously and appropriately publish on each copy an appropriate
##copyright notice and disclaimer of warranty; keep intact all the
##notices that refer to this License and to the absence of any warranty;
##and give any other recipients of the Program a copy of this License
##along with the Program.

##You may charge a fee for the physical act of transferring a copy, and
##you may at your option offer warranty protection in exchange for a fee.

##  2. You may modify your copy or copies of the Program or any portion
##of it, thus forming a work based on the Program, and copy and
##distribute such modifications or work under the terms of Section 1
##above, provided that you also meet all of these conditions:

##    a) You must cause the modified files to carry prominent notices
##    stating that you changed the files and the date of any change.

##    b) You must cause any work that you distribute or publish, that in
##    whole or in part contains or is derived from the Program or any
##    part thereof, to be licensed as a whole at no charge to all third
##    parties under the terms of this License.

##    c) If the modified program normally reads commands interactively
##    when run, you must cause it, when started running for such
##    interactive use in the most ordinary way, to print or display an
##    announcement including an appropriate copyright notice and a
##    notice that there is no warranty (or else, saying that you provide
##    a warranty) and that users may redistribute the program under
##    these conditions, and telling the user how to view a copy of this
##    License.  (Exception: if the Program itself is interactive but
##    does not normally print such an announcement, your work based on
##    the Program is not required to print an announcement.)
##
##These requirements apply to the modified work as a whole.  If
##identifiable sections of that work are not derived from the Program,
##and can be reasonably considered independent and separate works in
##themselves, then this License, and its terms, do not apply to those
##sections when you distribute them as separate works.  But when you
##distribute the same sections as part of a whole which is a work based
##on the Program, the distribution of the whole must be on the terms of
##this License, whose permissions for other licensees extend to the
##entire whole, and thus to each and every part regardless of who wrote it.

##Thus, it is not the intent of this section to claim rights or contest
##your rights to work written entirely by you; rather, the intent is to
##exercise the right to control the distribution of derivative or
##collective works based on the Program.

##In addition, mere aggregation of another work not based on the Program
##with the Program (or with a work based on the Program) on a volume of
##a storage or distribution medium does not bring the other work under
##the scope of this License.

##  3. You may copy and distribute the Program (or a work based on it,
##under Section 2) in object code or executable form under the terms of
##Sections 1 and 2 above provided that you also do one of the following:

##    a) Accompany it with the complete corresponding machine-readable
##    source code, which must be distributed under the terms of Sections
##    1 and 2 above on a medium customarily used for software interchange; or,

##    b) Accompany it with a written offer, valid for at least three
##    years, to give any third party, for a charge no more than your
##    cost of physically performing source distribution, a complete
##    machine-readable copy of the corresponding source code, to be
##    distributed under the terms of Sections 1 and 2 above on a medium
##    customarily used for software interchange; or,

##    c) Accompany it with the information you received as to the offer
##    to distribute corresponding source code.  (This alternative is
##    allowed only for noncommercial distribution and only if you
##    received the program in object code or executable form with such
##    an offer, in accord with Subsection b above.)

##The source code for a work means the preferred form of the work for
##making modifications to it.  For an executable work, complete source
##code means all the source code for all modules it contains, plus any
##associated interface definition files, plus the scripts used to
##control compilation and installation of the executable.  However, as a
##special exception, the source code distributed need not include
##anything that is normally distributed (in either source or binary
##form) with the major components (compiler, kernel, and so on) of the
##operating system on which the executable runs, unless that component
##itself accompanies the executable.

##If distribution of executable or object code is made by offering
##access to copy from a designated place, then offering equivalent
##access to copy the source code from the same place counts as
##distribution of the source code, even though third parties are not
##compelled to copy the source along with the object code.
##
##  4. You may not copy, modify, sublicense, or distribute the Program
##except as expressly provided under this License.  Any attempt
##otherwise to copy, modify, sublicense or distribute the Program is
##void, and will automatically terminate your rights under this License.
##However, parties who have received copies, or rights, from you under
##this License will not have their licenses terminated so long as such
##parties remain in full compliance.

##  5. You are not required to accept this License, since you have not
##signed it.  However, nothing else grants you permission to modify or
##distribute the Program or its derivative works.  These actions are
##prohibited by law if you do not accept this License.  Therefore, by
##modifying or distributing the Program (or any work based on the
##Program), you indicate your acceptance of this License to do so, and
##all its terms and conditions for copying, distributing or modifying
##the Program or works based on it.

##  6. Each time you redistribute the Program (or any work based on the
##Program), the recipient automatically receives a license from the
##original licensor to copy, distribute or modify the Program subject to
##these terms and conditions.  You may not impose any further
##restrictions on the recipients' exercise of the rights granted herein.
##You are not responsible for enforcing compliance by third parties to
##this License.

##  7. If, as a consequence of a court judgment or allegation of patent
##infringement or for any other reason (not limited to patent issues),
##conditions are imposed on you (whether by court order, agreement or
##otherwise) that contradict the conditions of this License, they do not
##excuse you from the conditions of this License.  If you cannot
##distribute so as to satisfy simultaneously your obligations under this
##License and any other pertinent obligations, then as a consequence you
##may not distribute the Program at all.  For example, if a patent
##license would not permit royalty-free redistribution of the Program by
##all those who receive copies directly or indirectly through you, then
##the only way you could satisfy both it and this License would be to
##refrain entirely from distribution of the Program.

##If any portion of this section is held invalid or unenforceable under
##any particular circumstance, the balance of the section is intended to
##apply and the section as a whole is intended to apply in other
##circumstances.

##It is not the purpose of this section to induce you to infringe any
##patents or other property right claims or to contest validity of any
##such claims; this section has the sole purpose of protecting the
##integrity of the free software distribution system, which is
##implemented by public license practices.  Many people have made
##generous contributions to the wide range of software distributed
##through that system in reliance on consistent application of that
##system; it is up to the author/donor to decide if he or she is willing
##to distribute software through any other system and a licensee cannot
##impose that choice.

##This section is intended to make thoroughly clear what is believed to
##be a consequence of the rest of this License.
##
##  8. If the distribution and/or use of the Program is restricted in
##certain countries either by patents or by copyrighted interfaces, the
##original copyright holder who places the Program under this License
##may add an explicit geographical distribution limitation excluding
##those countries, so that distribution is permitted only in or among
##countries not thus excluded.  In such case, this License incorporates
##the limitation as if written in the body of this License.

##  9. The Free Software Foundation may publish revised and/or new versions
##of the General Public License from time to time.  Such new versions will
##be similar in spirit to the present version, but may differ in detail to
##address new problems or concerns.

##Each version is given a distinguishing version number.  If the Program
##specifies a version number of this License which applies to it and "any
##later version", you have the option of following the terms and conditions
##either of that version or of any later version published by the Free
##Software Foundation.  If the Program does not specify a version number of
##this License, you may choose any version ever published by the Free Software
##Foundation.

##  10. If you wish to incorporate parts of the Program into other free
##programs whose distribution conditions are different, write to the author
##to ask for permission.  For software which is copyrighted by the Free
##Software Foundation, write to the Free Software Foundation; we sometimes
##make exceptions for this.  Our decision will be guided by the two goals
##of preserving the free status of all derivatives of our free software and
##of promoting the sharing and reuse of software generally.

##			    NO WARRANTY

##  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
##FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
##OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
##PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
##OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
##TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
##PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
##REPAIR OR CORRECTION.

##  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
##WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
##REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
##INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
##OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
##TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
##YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
##PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
##POSSIBILITY OF SUCH DAMAGES.

##		     END OF TERMS AND CONDITIONS
##
##	    How to Apply These Terms to Your New Programs

##  If you develop a new program, and you want it to be of the greatest
##possible use to the public, the best way to achieve this is to make it
##free software which everyone can redistribute and change under these terms.

##  To do so, attach the following notices to the program.  It is safest
##to attach them to the start of each source file to most effectively
##convey the exclusion of warranty; and each file should have at least
##the "copyright" line and a pointer to where the full notice is found.

##    <one line to give the program's name and a brief idea of what it does.>
##    Copyright (C) <year>  <name of author>

##    This program is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or
##    (at your option) any later version.

##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.

##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


##Also add information on how to contact you by electronic and paper mail.

##If the program is interactive, make it output a short notice like this
##when it starts in an interactive mode:

##    Gnomovision version 69, Copyright (C) year name of author
##    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
##    This is free software, and you are welcome to redistribute it
##    under certain conditions; type `show c' for details.

##The hypothetical commands `show w' and `show c' should show the appropriate
##parts of the General Public License.  Of course, the commands you use may
##be called something other than `show w' and `show c'; they could even be
##mouse-clicks or menu items--whatever suits your program.

##You should also get your employer (if you work as a programmer) or your
##school, if any, to sign a "copyright disclaimer" for the program, if
##necessary.  Here is a sample; alter the names:

##  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
##  `Gnomovision' (which makes passes at compilers) written by James Hacker.

##  <signature of Ty Coon>, 1 April 1989
##  Ty Coon, President of Vice

##This General Public License does not permit incorporating your program into
##proprietary programs.  If your program is a subroutine library, you may
##consider it more useful to permit linking proprietary applications with the
##library.  If this is what you want to do, use the GNU Library General
##Public License instead of this License.

import sys
import re
import string
import types
import os
import glob
import shutil
import time
import copy
import xml.sax
import xml.sax.handler
from xml.sax.saxutils import escape
import zipfile

from reportlab.platypus import SimpleDocTemplate, BaseDocTemplate,PageTemplate,Paragraph,Spacer,Frame,Table,TableStyle,KeepTogether,PageBreak,ActionFlowable,Image,NextPageTemplate,CondPageBreak
from reportlab.platypus.doctemplate import IndexingFlowable
from reportlab.lib.styles import getSampleStyleSheet
from reportlab.rl_config import defaultPageSize
from reportlab.lib.pagesizes import A4,A5,landscape,portrait
from reportlab.lib.units import inch, cm
from reportlab.lib import colors

try:
     # Imports for the "Bezirkreiter"-Software
     import normalDate
     import datumutilities
     import verschiedeneUtilities
     import sortieren
except:
     pass

PAGE_HEIGHT=defaultPageSize[1]
PAGE_WIDTH = defaultPageSize[0]
STYLES = getSampleStyleSheet()
SKIP={"underline": 0,"images": 0,"tables": 0, "all": 0}
VERBOSE = 0
# be careful with the globals when deriving classes!

def plattformTesten():
    """Tests the current platform: win95, winNT, other.""" 
    win = 0
    win_nt = 0
    try:
        if sys.platform[:3] == "win":
            win = 1
            try:
                if (os.environ["OS"].lower()).find("nt") != -1 and win:
                    # os.environ["OS"] nicht unter Linux und Win95!
                    win_nt = 1
            except:
                pass
    except:
        pass
    return win, win_nt

class Regexes:
     def __init__(self):
        self.datumsform = re.compile(r"((\d?\d)\.\s?(\d?\d)\.\s?(\d\d\d\d))")
        self.datumstext = re.compile(r"((\d?\d)\.\s?(Januar|Februar|Mrz|April|Mai|Juni|Juli|August|September|Oktober|November|Dezember)\s?(\d\d\d\d))")
        self.monate = {"Januar":"01", "Februar":"02", "Mrz":"03", "April":"04","Mai":"05","Juni":"06","Juli":"07","August":"08","September":"09","Oktober":"10","November":"11","Dezember":"12"}


## Textutilities: An utility-class for different text operations.
## I wrote this module originally for a church administration software ("Bezirksreiter" => www.bezirksreiter.de)
## This software was written for German language users, so unfortunately many comments and names in "Textutilities" are in German - sorry.
## I hope I can fix this one day...

class Textutilities:
    def __init__(self):
         self.win, self.win_nt = plattformTesten()

    def csvdatei_einlesen(self,datei="/home/martin/skripte/python/gemeindekartei.txt",trenner="\t",datumumwandeln="nein",nichtaendern=["Telefon","Fax", "EMail"]):
        """Spaltenberschriften als erste Zeile werden nicht gesondert behandelt!
        Rckgabeformat: Liste von Liste."""
        # *** TODO: Probleme bei leeren Datenfeldern? (reprsentiert z.B. von zwei aufeinanderfolgenden Tabs)
        sortierwerkzeug = sortieren.Sortieren()
        rueck_matrix = []
        try:
            f = open(datei,'r')
        except:
            print "Wo ist Datei %s?" %datei
            return 0
        inhalt = f.readlines()
        ## inhalt = map(lambda x: string.rstrip(x), inhalt)
        ## Alle angehngten Returns weg => nein - Schwierigkeiten bei
        ## Leerfeldern. Wird in importUmwandeln pro Feld gemacht s.u.
        kategorien = string.split(inhalt[0],trenner)
        laenge = len(kategorien)
        ## print kategorien
        for i in inhalt:
            temp = string.split(i,trenner)
            if len(temp) != laenge:
                # print "Content-type: text/html\n"
                print "Importierte Datenbank %s ist inkonsistent bei Element %s." %(datei,temp)
                return 0
            else:
                rueck_matrix.append(temp)        
        f.close()
        # Sonderbehandlungen fr jedes Datenfeld:
        rueck_matrix = sortierwerkzeug.mapAll(rueck_matrix,funktion=self.importUmwandeln)
        if datumumwandeln == "ja":            
            temp = sortierwerkzeug.mapAll(rueck_matrix,funktion=self.datumParsen,nichtaendern=nichtaendern)
            return temp
        else:
            return rueck_matrix

    def alsDictionary(self,spalten,array):
        # macht aus einem Array von Array ein
        # Array von Dictionaries, jeweils mit den
        # Namen aus "spalten" als Schlssel
        temparray = []
        for i in array:
            tempdict = {}
            for j in range(len(spalten)):
                tempdict[spalten[j]] = i[j]
            temparray.append(tempdict)
        return temparray    

    def importUmwandeln(self,string):
         """Gibt an, wie jedes einzelne Datenfeld - unabhngig von
         datumParsen - noch behandelt werden soll."""
         # Einige Tabellenkalkulationen exportieren mit
         # besonderen "Text-Trenner"-Zeichen.
         string = string.replace('\"','')
         string = string.replace("\'","")
         string = string.strip()
         # keine fhrenden oder angehngten Spaces usw.
         return string
         

    def datumParsen(self,string):
        """gibt ein erkanntes Datum als ISO-String
        JJJJ-MM-TT zurck, sonst den String selbst.
        Erlaubte Eingabeformate: "TT/MM/JJJJ" oder "TT.MM.JJJJ"
        oder "TT. Monatsname(deutsch ohne Abkrzung: "September") JJJJ".
        Ist tolerant gegen fehlende Spaces.
        Damit nicht jedes Textutilities-Objekt die komplizierten Regexes
        kompilieren mu, erscheinen sie nur hier und nicht in __init__."""
        datumsform = re.compile(r"((\d?\d)[\.\/]\s?(\d?\d)[\.\/]\s?(\d\d\d\d))")
        # *** TODO: ggf. noch abgekrzte Monatsnamen wie Apr. oder Mrz. behandeln.
        datumstext = re.compile(r"((\d?\d)\.\s?(Januar|Februar|Mrz|April|Mai|Juni|Juli|August|September|Oktober|November|Dezember)\s?(\d\d\d\d))")
        monate = {"Januar":"01", "Februar":"02", "Mrz":"03", "April":"04","Mai":"05","Juni":"06","Juli":"07","August":"08","September":"09","Oktober":"10","November":"11","Dezember":"12"}
        mobj = datumsform.search(string)
        if mobj is not None:
            # Korrekte Vornullen:
            tag = "%02d" % int(mobj.group(2))
            monat = "%02d" % int(mobj.group(3))
            jahr = "%04d" % int(mobj.group(4))
            return "%s-%s-%s" % (jahr,monat,tag)
        mobj = datumstext.search(string)
        if mobj is not None:
            tag = "%02d" % int(mobj.group(2))
            temp = mobj.group(3)
            jahr = "%04d" % int(mobj.group(4))
            monat = monate[temp]
            return "%s-%s-%s" % (jahr,monat,tag) 
        # Wenn kein Treffer:
        return string
        

    def csvDateiSchreiben(self,matrix,dateiname,trenner="\t",alsString="nein"):
         """Schreibt eine Liste von einer Liste in eine Datei,
         berschreibt ggf. ohne Nachfrage!"""
         string1 = ""         
         for zeile in matrix:
              for spalte in zeile:
                   string1 += """%s%s""" % (spalte,trenner)
              string1 = string1[:-1] + '\n'
              # letzter Tab weg, statt dessen Return
              # *** Achtung bei Windows wg. Zeilentrenner! ***
              # Automatische Umwandlung beim Schreiben?
              # ggf. os.linesep statt "\n" verwenden.
         if alsString == "ja":
              return string1
         else:
              try:
                   file = open(dateiname,'w') 
                   file.write(string1)
                   file.close()
                   return 1
              except:
                   # zur Lesbarkeit in CGI-Umgebungen:
                   print "Content-type: text/html\n"            
                   print "<H3>Konnte nicht in Datei %s schreiben!</H3>" % dateiname
                   return 0
    
    def extract_tags(self, starttag, endtag, startposition, inhalt,mitTags="ja"):
        ## sucht in einem XML/HTML(hnlichen)-String zwischen denen als Regex-Objekt
        ## angegebenen Tags Tabellen usw.
        startobj = starttag.search(inhalt, startposition)
        if not startobj:
            ## wenn kein Treffer:
            return ('',0)     
        endobj = endtag.search(inhalt, startposition)
        # TODO:
        if not endobj:
             # for example for empty paragraphs: <text:p ....... />
             return ('',startposition+1)
        if mitTags == "ja":
             startposition = startobj.start()
             endposition = endobj.end()
        elif mitTags == "nein":
             startposition = startobj.end()
             endposition = endobj.start()
        # print startposition, endposition
        if (startposition <= endposition):    
            extractstring = inhalt[startposition:endposition]
            # TODO:
            # print endposition
            return (extractstring, endposition)
        else:
            sys.exit("Ober- und Untergrenze vertauscht in textutilities.extract_tags!")

    def extract_tags_all(self,starttag,endtag,inhalt,mitTags="ja"):
       """Like extract_tags, but returns a list of all matches."""
       startposition = 0
       list = []
       temp = self.extract_tags(starttag=starttag,endtag=endtag,startposition=startposition,inhalt=inhalt,mitTags=mitTags)
       while temp[0]:
          list.append(temp[0])
          startposition = temp[1]
          temp = self.extract_tags(starttag,endtag,startposition,inhalt,mitTags=mitTags)
       return list

    def remove_tags(self, starttag, endtag, inhalt,mitTags="ja"):
        ## Beseitigt aus einem Text alles zwischen starttag und endtag
        ## auch bei mehreren Vorkommen. starttag und endtag sind
        ## re-Objekte, s.o. Bei mitTags = "ja" werden auch die Tags mitgelscht.
        position = 0
        ausgabe = ""
        ##temp = ""
        while 1:
            startobj = starttag.search(inhalt,position)
            if not startobj:
                 ## fr den "Schwanz":
                 if mitTags == "ja":
                      ausgabe = ausgabe+inhalt[position:]
                 else:
                      ausgabe = ausgabe+inhalt[endobj.start():]
                 break                
            else:
                 endobj = endtag.search(inhalt,position)
                 startposition = startobj.start()
                 endposition = endobj.end()
                 if mitTags == "ja":
                      ausgabe = ausgabe+inhalt[position:startposition]
                 else:
                      ausgabe = ausgabe+inhalt[position:startobj.end()]
                 position = endposition                
        return ausgabe

    def bildschirmLoeschen(self):
         """Arbeitet mit ANSI-Escape-Sequenzen. Fr DOS nicht vergessen,
         ansi.sys einzubinden."""
         print "\033[2J"
         print "\033[0;0H"

    def konfigurationEinlesen(self,text):
         """Liest einen Text (z.B. aus einer Konfigurationsdatei) ein, gibt die Daten
         in einem Dictionary zurck. Primitiv und nicht sehr fehlertolerant. Windows-geeignet?
         (Wegen Zeilenendezeichen)"""
         alleZeilen = text.split("\n")
         datendict = {}
         for i in alleZeilen:
              try:
                   if i[0] == "#":
                        # Kommentarzeilen berspringen.
                        continue
                   i = i.rstrip()
                   templist = i.split("=")
                   datendict[templist[0]] = "%s" % templist[1]
              except:
                   # hier werden z.B. leere oder falsche Zeilen behandelt:
                   pass
         return datendict

    def schluesselworteFinden(self,text,wortliste,ohneSpaces="ja"):
         if ohneSpaces == "ja":
              text = text.strip()
              wortliste = [i.strip() for i in wortliste]
         templist = []
         for i in wortliste:
              if text.find(i) != -1:
                   templist.append(i)
         return templist

    def schluesselworteExtrahieren(self,text,wortliste,ohneSpaces="ja"):
         """Entfernt aus einem String alle Wrter aus Wortliste."""
         if ohneSpaces == "ja":
              text = text.strip()
              wortliste = [i.strip() for i in wortliste]
              # wenn text und wortliste aus einer Datenbank o.a. stammen, knnten vorne oder hinten
              # z.B. Spaces sein.
         for wort in wortliste:
              text = text.replace(wort,"")
         return text

    def abkuerzungenTesten(self,text,wortliste):
         """Soll einen Text darauf testen, ob er lediglich eine Anzahl von Abkrzungen
         enthlt, ggf. getrennt durch Spaces, Kommas usw. z.B. fr Tests von
         Datenbankfeldern."""
         ohne_schluessel_text = self.schluesselworteExtrahieren(text,wortliste,ohneSpaces="ja")
         dict = {" ": None, "\n": None, ",": None, ";": None, "\"": None, "\'": None}
         # so nutzen wir den schnellen Hash-Algorithmus der dict-Klasse, um ggf. Trenner-
         # zeichen u.. zu entfernen.
         returntext = ""
         for i in ohne_schluessel_text:
              if dict.has_key(i):
                   continue
              else:
                   returntext += i
         # wenn returntext immer noch "", dann waren im zu testenden Text nur
         # gltige Abkrzungen.
         return {"TestText": returntext,"ReduzierterText": ohne_schluessel_text}

    def stringErsetzenDatei(self,datei,stringalt,stringneu):
         """Eine sichere Methode, einen String zu ersetzen in einer Datei.
         bercksichtigt das verzgerte Setzen von Rechten bei Windows usw."""
         os.chmod(datei,0777)
         tempfile = open(datei,"rb")
         inhalt = tempfile.read()
         tempfile.close()
         inhalt = string.replace(inhalt,stringalt,stringneu)
         os.chmod(datei,0777)
         if self.win:
              time.sleep(1)            
              # eine Zeitschleife, weil (liegt es daran?) in Windows
              # manchmal die Schreibberechtigung zu spt gesetzt wird.
         tempfile = open(datei,"wb")
         tempfile.write(inhalt)
         tempfile.close()

    def openOfficeLesen(self,datei):
         """Liest die content.xml-Datei eines OO-"Archivs"."""
         z = zipfile.ZipFile(datei,"r")
         inhalt = z.read("content.xml")
         z.close()
         return inhalt

    def openOfficePagebreakstyle(self):
         """Very primitive. Assumes that you will never more than 2000 automatic-styles..."""
         return """ <style:style style:name="P2000" style:family="paragraph" style:parent-style-name="Standard"><style:properties fo:break-after="page"></style:properties></style:style>"""

    def openOfficePagebreakstyleEinsetzen(self,content):
         if content.find("style:name=\"P2000\"") == -1:
              return content.replace("""</office:automatic-styles>""",self.openOfficePagebreakstyle()+"""</office:automatic-styles>""")
         else:
              return content

    def openOfficeMergetextPruefen(self,text):
         """Manche XML-Styles machen bei dieser primitiven Merge-Methode Probleme,
         deshalb dieser Test. Achtung, berall nur reine ASCII-Zeichen nehmen, keine Umlaute!"""
         rueckgabe = text
         flag = 1
         testdict = {"text:anchor-type=\"page\"": {"Beschreibung": "Verankerung an der Seite","Ersatz": "Verankerung am Absatz"}}
         # Dieser testdict kann ergnzt werden.
         for style in testdict.keys():
              if (rueckgabe.find(style) != -1) and VERBOSE:
                   warntext = """Problem: Ihr(e) OpenOffice-Dokument(vorlage) enthaelt irgendwo das Element "%s" (XML: %s). Ersetzungsvorschlag: "%s".#####""" % (testdict[style]["Beschreibung"],style,testdict[style]["Ersatz"])
                   # Achtung, Test:
                   print "Content-type: text/html\n"
                   print "<H3>"+warntext+"</H3>"
                   flag = 0
         return flag              

    def openOfficeMerge(self,content1,content2,pagebreak="ja"):
         """Ergnzt bei der content.xml-Datei des ersten OO-Archivs in <office:body> den Inhalt von
         <office:body> der zweiten Datei. Nur die automatic-styles der ersten Datei werden bernommen."""
         body_start = re.compile(r"<office:body>")
         body_end = re.compile(r"<\/office:body>")
         body_1 = self.extract_tags(body_start,body_end,0,content1,mitTags="nein")[0]
         body_2 = self.extract_tags(body_start,body_end,0,content2,mitTags="nein")[0]
         self.openOfficeMergetextPruefen(body_2)
         content_neu = self.remove_tags(body_start,body_end,content1,mitTags="nein")
         if pagebreak == "ja":
              content_neu = self.openOfficePagebreakstyleEinsetzen(content_neu)
              return content_neu.replace("<office:body>","<office:body>"+body_1+"""<text:p text:style-name="P2000" />"""+body_2)
         else:
              return content_neu.replace("<office:body>","<office:body>"+body_1+body_2)         

    def openOfficeErsetzen(self,datei,inhalt,neuedatei=None):
         datei = datei
         if neuedatei:
              shutil.copyfile(datei,neuedatei)
              datei = neuedatei
         # Achtung, Windows-Falle?
         # os.chmod(datei,0777)
         # evtl. noch s.o.:
         #if self.win:
         #     time.sleep(1)
         z = zipfile.ZipFile(datei,"r")
         zipinfo = z.getinfo("content.xml")
         z.close()
         z = zipfile.ZipFile(datei,"a")
         z.writestr(zipinfo,inhalt)
         z.close()

    def openOfficeReplacePictures(self,file,pic_list):
         """Try to replace all embedded pictures by the content
         of the files from pic_list. Keep the order in the sxw-file
         and map it to the order from pic_list.
         Return the filename of the generated file.
         If no replacement was possible, the name of the original file will be returned."""
         tempfile = open(file,"rb")
         file_content = tempfile.read()
         tempfile.close()
         # save content of the old file
         import Image
         content = self.openOfficeLesen(file)
         re_pic = re.compile(r"xlink:href=\"#Pictures/(.*?)\"",re.DOTALL | re.IGNORECASE | re.UNICODE)
         re_im = re.compile(r"(<draw:image.*?(svg:width=\"(.*?)(cm|inch)\").*?(svg:height=\"(.*?)(cm|inch)\").*?(xlink:href=\"#Pictures/(.*?)\").*?>)",re.DOTALL | re.IGNORECASE | re.UNICODE)
         all = re_im.findall(content)
         list = re_pic.findall(content)
         check = file
         if (list == []) or (pic_list == []):
              return file
         try:
              for index in range(len(list)):
                   whole_pic = all[index][0]
                   if index > len(pic_list)-1:
                        content = content.replace(whole_pic,"")
                        # go on to the next picture to be replaced with empty space:
                        continue
                   #print "index: ",index
                   im = Image.open(pic_list[index])
                   #print "size: ", im.size
                   proportion = float(im.size[1])/float(im.size[0])
                   # the proportion of the new picture to be embedded.
                   pic_file = all[index][8]
                   height = all[index][4]
                   heigth_value_string = all[index][5]
                   width_value = float(all[index][2])
                   new_height_string = "%s" % (width_value * proportion)
                   new_height = height.replace(heigth_value_string,new_height_string)
                   new_picfilename = pic_file.split(".")[0] + pic_list[index]
                   # do not use the filenname of the inserted picture file to store it in the sxw-file:
                   # the file may be deleted by the house cleaning routine of makeSafePdf().
                   new_whole_pic = whole_pic.replace(pic_file,self.openOfficeStringUtf8(new_picfilename))
                   new_whole_pic = new_whole_pic.replace(height,new_height)
                   #print "old_height: ", height
                   #print "new_height: ",new_height
                   content = content.replace(whole_pic,new_whole_pic)
                   self.openOfficeReplacePictureFile(file=file,old_pic=list[index],new_pic=pic_list[index],new_picfilename=new_picfilename)
              self.openOfficeErsetzen(datei=file,inhalt=content,neuedatei="NewPics_"+file)
              tempfile = open(file,"wb")
              tempfile.write(file_content)
              tempfile.close()
              # restore template file
              check = "NewPics_" + file
         except:
              pass
         return check

    def openOfficeReplacePictureFile(self,file,old_pic,new_pic,new_picfilename):
         """Replace a file of the Pictures-Directory in
         the sxw-archive."""
         check = 0
         try:
            z = zipfile.ZipFile(file,"r")
            zipinfo = z.getinfo("Pictures/" + old_pic)
            z.close()
            z = zipfile.ZipFile(file,"a")           
            z.writestr(zipinfo,"")
            # replace old_pic by an empty string to save space.
            # TODO: the old_pic is not deleted in the Pictures-directory of the
            # sxw-archive. Seems to be no problem.
            z.write(new_pic,"Pictures/" + new_picfilename)
            z.close()
            check = 1
         except:
            pass
         return check

    def openOfficeReplaceKeyCheck(self,string,list_of_keys,multi=0):
         """Checks the string for TFA-key-TFE or Multi:TFA-key-TFE fields.
         Returns 1, if at least one field is in the string."""
         returnflag = 0
         field = """TFA-%s-TFE"""
         if multi:
              field = """Multi:TFA-%s-TFE"""
         for key in list_of_keys:
              if string.find((field % key)) != -1:
                   returnflag = 1
         return returnflag
              

    def openOfficeMultiReplaceTables(self,content,listofdicts,tags=("TFA-","-TFE")):
       """Replaces one table-row with the records from listofdicts.
       TODO: is it useful to use other tags?"""
       newcontent = copy.copy(content)
       re_table_left = re.compile(r"<table:table.*?>",re.DOTALL | re.IGNORECASE | re.UNICODE)
       re_table_right = re.compile(r"</table:table>",re.DOTALL | re.IGNORECASE | re.UNICODE)
       re_row_left = re.compile(r"<table:table-row.*?>",re.DOTALL | re.IGNORECASE | re.UNICODE)
       re_row_right = re.compile(r"</table:table-row>",re.DOTALL | re.IGNORECASE | re.UNICODE)
       tables = self.extract_tags_all(starttag=re_table_left,endtag=re_table_right,inhalt=content)
       for table in tables:
            old_table = copy.copy(table)
            rows = self.extract_tags_all(starttag=re_row_left,endtag=re_row_right,inhalt=table)
            for row in rows:
                 temptext = ""
                 if row.find("Multi:TFA-") != -1:
                     for dict in listofdicts:
                          if not self.openOfficeReplaceKeyCheck(string=row,list_of_keys=dict.keys(),multi=1):
                               continue
                          new_row = copy.copy(row)
                          for key in dict.keys():
                               # TODO: only use hardcoded tags?
                               new_row = new_row.replace(self.openOfficeStringUtf8("Multi:TFA-%s-TFE" % key), self.openOfficeStringUtf8(dict[key]))
                          temptext += new_row
                 else:
                      temptext += row
            table = table.replace(row,temptext)
            newcontent = newcontent.replace(old_table,table)
       return newcontent

    def openOfficeMultiReplaceParagraphs(self,content,listofdicts,tags=("TFA-","-TFE")):
         """Replaces one paragraph with the records from listofdicts. Use the line-break-sign in the
         sxw-document (shift-return in OO) instead of carriage-return to print multi-line-records
         for example: Surname - linebreak - First Name - linebreak - City.
         TODO: this function is not safe yet. It is switched off by default."""
         re_paragraph_left = re.compile(r"<text:p.*?/>",re.DOTALL | re.IGNORECASE | re.UNICODE)
         re_paragraph_right = re.compile(r"</text:p>",re.DOTALL | re.IGNORECASE | re.UNICODE)
         re_paragraph_empty = re.compile(r"<text:p.*?>",re.DOTALL | re.IGNORECASE | re.UNICODE)
         re_table_left = re.compile(r"<table:table.*?>",re.DOTALL | re.IGNORECASE | re.UNICODE)
         re_table_right = re.compile(r"</table:table>",re.DOTALL | re.IGNORECASE | re.UNICODE)
         oldcontent = copy.copy(content)
         content = self.remove_tags(starttag=re_table_left,endtag=re_table_right,inhalt=content) 
         content = self.openOfficeRemoveEmptyParagraphs(content)
         # remove all tables and empty paragraphs first. Then extract:
         paragraphs = self.extract_tags_all(starttag=re_paragraph_left,endtag=re_paragraph_right,inhalt=content)
         for p in paragraphs:
              old_p = ""
              temptext = ""
              if p.find("Multi:TFA-") != -1:
                   for dict in listofdicts:
                        old_p = copy.copy(p)
                        for key in dict.keys():
                             old_p = old_p.replace(self.openOfficeStringUtf8("Multi:TFA-%s-TFE" % key), self.openOfficeStringUtf8(dict[key]))
                        temptext += old_p
              oldcontent = oldcontent.replace(p,temptext)
         return oldcontent

    def openOfficeRemoveEmptyParagraphs(self,content):
         """Removes all empty paragraphs from content."""
         re_paragraph_start = re.compile(r"<text:p.*?>",re.DOTALL | re.IGNORECASE | re.UNICODE)
         list = re_paragraph_start.findall(content)
         for p in list:
              if p[-2:] == "/>":
                   # print "hier"
                   content = content.replace(p,"")
         return content
       
    def openOfficeMultiReplace(self,sourcefile,replace_listofdicts,tags=("TFA-","-TFE"),as_file=1,with_paragraphs=0):
         """Multiple replace of tables-rows and paragraphs. Working without an XML-Parser - fast, but primitive.
         Use only custom fields with pure ASCII-Sign - not "TFA-GermanUmlaute-TFE" etc."""  
         content = self.openOfficeLesen(sourcefile)         
         file = "Multi%s_%s" % (len(replace_listofdicts),sourcefile)
         newcontent = self.openOfficeMultiReplaceTables(content=content,listofdicts = replace_listofdicts)
         # ****** very important: replace table-rows first - table-cells consist of paragraphs! ******
         if with_paragraphs:
              newcontent = self.openOfficeMultiReplaceParagraphs(content=newcontent,listofdicts = replace_listofdicts)
         if as_file:
              self.openOfficeErsetzen(datei=sourcefile,inhalt=newcontent,neuedatei=file)
              return file
         else:
              return newcontent   

    def openOfficeSerialLetter(self,sourcefile,replace_listofdicts,one_file=1,tags=("TFA-","-TFE"),content=""):
         """Takes an sxw-file and a list of dictionaries, makes many documents from it
         by replacement. The startag and endtag defaults are from the "Bezirksreiter"-Software.
         If one_file is set to 0, it will be saved as one document per record, otherwise everything
         will be in one document. When using frames in the sxw-document: do not use "anchor-type:page".
         Working without an XML-Parser: fast, but primitive.
         You may pass a preprocessed content, then sourcefile is only used for the output file name.
         TODO: the tags only may contain ascii-signs.
         Use only custom fields with pure ASCII-Sign - not "TFA-GermanUmlaute-TFE" etc."""
         if not content:
              content = self.openOfficeLesen(sourcefile)
         counter = 0
         outcontent = ""
         content = content.replace("TFA-heute-TFE",self.openOfficeStringUtf8(self.heute()))
         content = content.replace("TFA-today-TFE",self.openOfficeStringUtf8(self.today()))
         # current date - TODO: very primitive.
         first_time = 1
         file_list = []
         found_replace_field = 0
         for record in replace_listofdicts:
              if not self.openOfficeReplaceKeyCheck(string=content,list_of_keys=record.keys(),multi=0):
                   continue # skip "strange" records
              newcontent = copy.copy(content)
              for key in record.keys():
                   replace = self.openOfficeStringUtf8(record[key])
                   utf_key = self.openOfficeStringUtf8(key)
                   if newcontent.find("""%s%s%s""" % (tags[0],utf_key,tags[1]))   != -1:
                        #print utf_key
                        found_replace_field = 1 # at least one replace_field?
                   newcontent = newcontent.replace("""%s%s%s""" % (tags[0],utf_key,tags[1]),replace)
              if found_replace_field:
                   counter += 1
                   if one_file:
                        if first_time:
                             outcontent = copy.copy(newcontent)
                             first_time = 0
                        else:
                             outcontent = self.openOfficeMerge(outcontent,newcontent)
                   else:
                        file = "%s_%s" % (counter,sourcefile)
                        file_list.append(file)
                        self.openOfficeErsetzen(datei=sourcefile,inhalt=newcontent,neuedatei=file)
         if not found_replace_field:
              # no replace_fields found:
              new_file = "1Copies_%s" % sourcefile
              file_list = [new_file]
              self.openOfficeErsetzen(datei=sourcefile,inhalt=content,neuedatei=new_file)
              if one_file:
                   return new_file
              else:
                   return file_list              
         if one_file:
              new_file = "%sCopies_%s" % (counter,sourcefile)
              self.openOfficeErsetzen(datei=sourcefile,inhalt=outcontent,neuedatei=new_file)
              return new_file
         else:
              return file_list

    def heute(self):
        """Current date in German form."""
        _time = time.strftime('%d.%m.%Y', time.localtime(time.time()))
        return _time

    def today(self):
         """Current date"""
         _time = time.strftime('%d/%m/%Y', time.localtime(time.time()))
         return _time

    def openOfficeStringUtf8(self,string):
         if type(string) == unicode:
              # for Asian fonts etc.:
              return string.encode("utf-8")
         tempstring = unicode(string,"cp1252").encode("utf-8")
         return tempstring

    def openOfficeStringErsetzenDatei(self,datei,stringalt,stringneu):
         tempstring = self.openOfficeStringUtf8(stringneu)
         # wenn Umlaute etc. als neuer String eingesetzt werden.
         inhalt = self.openOfficeLesen(datei)
         inhalt = inhalt.replace(stringalt,tempstring)
         # stringalt darf keine Umlaute enthalten!
         self.openOfficeErsetzen(datei,inhalt)
         return 1    

    def privatStattDienstlich(self,dict):
        """Setzt bei  nicht vorhandener Dienstadresse die Privatadresse ein.
        Speziell fr Datenbank vom Typ emkadressen_neu"""
        trans = {"Strasse": "PrivatStrasse",
                 "Land": "PrivatLand",
                 "PLZ": "PrivatPLZ",
                 "Ort": "PrivatOrt",
                 "Telefon": "PrivatTelefon",
                 "Mail": "PrivatMail",
                 "Handy": "PrivatHandy",
                 "Fax": "PrivatFax"}
        tempdict = {}
        tempdict.update(dict)
        try:
             for t in trans.keys():
                  if tempdict[t] == "-" or tempdict[t] == "":
                       tempdict[t] = tempdict[trans[t]]
        except:
             pass # wenn ein leerer dict bergeben wurde.
        return tempdict

    def privatStattDienstlichDictarray(self,dictarray):
        # Achtung, neues Dictarray muss erzeugt werden! 
        tempdictarray = []
        try:
             for i in dictarray:
                 tempdictarray.append(self.privatStattDienstlich(i))
             return tempdictarray
        except:
             return dictarray # leerer dictarray s.o. 

class ooDocTemplate(BaseDocTemplate):
   def __init__(self,filename,LANDSCAPE=0,**kwargs):
      """Make a page template. TODO: only DIN A 4 portrait or landscape possible."""  
      apply(BaseDocTemplate.__init__,(self,filename),kwargs)
      if LANDSCAPE:
           frame3 = Frame(x1=1.5*cm,y1=2*cm,width=26.5*cm,height=17*cm,id="4")
           pt1 = PageTemplate(id="OneColumn",frames=[frame3],pagesize=landscape(A4))
      else:
           frame3 = Frame(x1=2*cm,y1=1.5*cm,width=17*cm,height=26.5*cm,id="4")
           pt1 = PageTemplate(id="OneColumn",frames=[frame3])
      self.addPageTemplates(pt1)
      self.stylesheet = getSampleStyleSheet()
      self.stylesheet_info = {"Normal": {"bold": 0,"italic": 0, "underline": 0}}
      self.stylesheet_info["Table Contents"] = self.stylesheet_info["Normal"]
      # font-weight etc. for paragraphs added for Platypus-XML-Markup
      self.tablestyle_border = {}
      # Table with border?
      self.style = self.stylesheet["Normal"]
      # TODO: always the default for tables?
      tempstyle = copy.copy(self.style)
      tempstyle.name = "Table Contents"
      self.stylesheet.add(tempstyle)
      self.style_body = self.stylesheet["BodyText"]
      self.style_h3 = self.stylesheet["Heading3"]
      self.stylesheet["Heading1"].spaceBefore = 14
      self.textMarkupStyles = {} # <font face="times"> etc.

class oo2pdf:
   """This class is responsible for the OO-to-PDF transformation. It builds up the "story" for the Platypus engine.
   Mind the different SKIP-flags."""
   global SKIP
   
   def __init__(self,filename="test.pdf",LANDSCAPE=0):
      self.Story = []
      self.filename = filename
      self.doc = ooDocTemplate(self.filename,LANDSCAPE=LANDSCAPE)
      self.markups = {"bold": ("""<b>""","""</b>"""),"italic": ("""<i>""","""</i>"""),"underline": ("""<u>""","""</u>""")}
      self.test_text1 = """text with German <i>Umlaute</i>""" + escape("&") + """XML-entity and <b>XML-Markup</b>: &quot;"""
      # mind the quoting
      self.skip = SKIP
      # for difficult cases
      self.Images = {}
      # used for caching of Image-Flowables

   def distancePoint(self,length=1,color="white"):
      """Produces a non-visible point, uses XML-Markup. For "Tabs" etc."""
      points = "." * length
      return """<font color="%s">%s</font>""" % (color,points)

   def addParagraphStyle(self,stylename,styledict={"fontName": "Times-Roman"}):
      """Add a new Paragraph Style to doc.stylesheet."""
      tempstyle = copy.copy(self.doc.style)
      #stylename = string.replace(stylename,"Heading ","Heading")
      self.doc.stylesheet_info[stylename] = {}
      for a in self.markups.keys():
         self.doc.stylesheet_info[stylename][a] = styledict.get(a,0)
      self.doc.stylesheet_info[stylename]["pageBreak"] = styledict.get("pageBreak")
      for k in styledict.keys():
         if not self.markups.has_key(k):
            tempstyle.__dict__[k] = styledict[k]
            # print tempstyle.__dict__
      tempstyle.name = stylename
      tempstyle.leading = tempstyle.fontSize + int(tempstyle.fontSize/5) + 1
      # print tempstyle.__dict__
      self.doc.stylesheet.add(tempstyle)

   def addTextStyle(self,stylename,oo_attrs,currentParagraphStyle=""):
      """Make XML-Markup-Tags from OO-text-styles. Used for intra-paragraph-markup.
      Problems with underlining (lines too short) - probably from a bug in the Platypus engine."""
      # print currentParagraphStyle
      italic_flag = 0
      temptext = """%s"""
      if oo_attrs.get("fo:font-style") == "italic":
         temptext = """<i>%s</i>""" % temptext
         italic_flag = 1
      if oo_attrs.get("fo:font-weight") == "bold":
         temptext = """<b>%s</b>""" % temptext
      if oo_attrs.get("style:text-underline") == "single":
         # TODO: ... and not...  but so it seems to work...
         if SKIP.get("underline"): #and not italic_flag:
            temptext = """<i>%s</i>""" % temptext
         else:
            temptext = """<u>%s</u>""" % temptext
      temp = ""
      size = oo_attrs.get("fo:font-size","nothing")
      if size[-2:] == "pt":
         temp = """size=%s""" % int(size[:-2])
      font = oo_attrs.get("style:font-name","")
      if font:
         temp += """ name="%s" """ % self.mapFontName(font)
      if temp:
         temptext = """<font %s>%s</font>""" % (temp,temptext)
      self.doc.textMarkupStyles[stylename]  = temptext

   def mapFontName(self,fontname):
      """Map the OO-Fonts to the standard fonts found in ReportLab."""
      if string.find(fontname,"Helvetica") != -1 or string.find(fontname,"Arial") != -1:
         return "Helvetica"
      if string.find(fontname,"Courier") != -1:
         return "Courier"
      else:
         return "Times-Roman"

   def mapParagraphStyle(self,oo_attrs):
      """Map the OO-automatic-styles to Reportlab-ParagraphStyles"""
      # TODO: Limitation: the entire OO-document must be formatted with the "Standard"-Paragraph-Style.
      # This function only maps the local(!) automatic-styles.
      styledict = {}
      if oo_attrs.get("fo:font-style") == "italic":
         styledict["italic"] = 1
      if oo_attrs.get("fo:font-weight") == "bold":
         styledict["bold"] = 1
      if oo_attrs.get("style:text-underline") == "single":
         if SKIP.get("underline"):
            styledict["italic"] = 1
         else:
            styledict["underline"] = 1
      if (oo_attrs.get("fo:break-before") == "page") or (oo_attrs.get("fo:break-after") == "page"):
         styledict["pageBreak"] = 1
      else:
         styledict["pageBreak"] = 0
      size = oo_attrs.get("fo:font-size","nothing")
      if size[-2:] == "pt":
         styledict["fontSize"] = int(size[:-2])
      font = oo_attrs.get("style:font-name","")
      # TODO: map the fontname to reportlab-fonts
      #if font:
      #   styledict["fontName"] = ("%s" % font).encode("latin-1") # convert from unicode
      styledict["fontName"] = self.mapFontName(font)
      styledict["alignment"] = self.mapParagraphAlignment(oo_attrs)
      if styledict["alignment"] == 4:
           SKIP["underline"] = 1
           # in a document with justified paragraphs never use underline -
           # it is a Platypus bug.
      #styledict["fontName"] = "Helvetica"
      return styledict

   def mapParagraphAlignment(self,oo_attrs):
      """Map the text alignment for the Platypus-Engine."""
      map = {"start": 0, "center": 1, "end": 2, "justify": 4}
      return map[oo_attrs.get("fo:text-align","start").encode("latin-1")]

   def mapPictureStyle(self,oo_attrs):
      """Map a picture-style, use very few attributes. Only works with embedded (not linked) pictures.
      TODO: Only works with cm and inch."""
      tempdict = {}
      #tempdict["filename"] = string.replace(oo_attrs.get("xlink:href","xxxxxxxxxxxxxxxxxx"),"""#Pictures/""","")
      tempdict["width"] = oo_attrs.get("svg:width",None) # use the default for Platypus      
      tempdict["height"] = oo_attrs.get("svg:height",None)
     ## for k in ("width","height"):
##         try:
##            tempdict[k] = float(string.replace(tempdict[k],"cm",""))
##         except:
##            tempdict[k] = float(string.replace(tempdict[k],"inch",""))
      return tempdict

   def normalizeTableContent(self,tableContent):
      """Normalizes tables with different row lengthes."""
      max_length = max([len(i) for i in tableContent])
      temp_content = []
      for c in tableContent:
         while len(c) < max_length:
            c.append(self.addEmptyParagraph("Normal",return_not_add=1))
         temp_content.append(c)
      return temp_content

   def addTable(self,tableContent,stylename):
      """Adds a hardcoded, simple-style table with a grid, the whole table with hAlign=LEFT."""
      tableContent = self.normalizeTableContent(tableContent)
      tempstyle = [("ALIGN",(0,0),(-1,-1),"LEFT"),
                   ("VALIGN",(0,0),(-1,-1),"TOP")]
      if self.doc.tablestyle_border.get(stylename):
         tempstyle.append(("GRID",(0,0),(-1,-1),0.5,colors.black))
      #table = Table(data,colWidths=3*[3*cm],style=tempstyle)
      table = Table(tableContent,style=tempstyle)
      table.hAlign = "LEFT"
      # Test:
      ##for r in tableContent:
##         counter = 1
##         for c in r:
##            print c
##            print "Number %s ------------------" % counter
##            counter += 1
##         print "##########################"
      self.Story.append(table)

   def addPicture(self,oo_attrs,picture_filename,picture_content,return_not_add=0):
      """Add a picture flowable to the "Story".
      TODO: There may be several different pictures!"""
      if not os.path.exists(picture_filename):
         file = open(picture_filename,"wb") # make a temporary picture file
         file.write(picture_content)
         file.close()
      tempdict = self.mapPictureStyle(oo_attrs)
      picture = None
      new_cache = 1
      new_flowable = 1
      if self.Images.has_key(picture_filename):
         temp_pic = self.Images[picture_filename]
         new_cache = 0
         if temp_pic["width"] == tempdict["width"] and temp_pic["height"] == tempdict["height"]:
            new_flowable = 0
      if new_flowable:
         ##unit = cm
##         temp = {"width": 0, "height": 0}
##         for k in ("width","height"):
##              try:
##                   temp[k] = float(string.replace(tempdict[k],"cm",""))
##              except:
##                   temp[k] = float(string.replace(tempdict[k],"inch",""))
##                   unit = inch
         width = self.mapUnits(tempdict["width"])
         height = self.mapUnits(tempdict["height"])
         picture = Image(picture_filename,width=width,height=height)
      elif (not new_cache) and (not new_flowable):
         picture = self.Images[picture_filename]["picture"]
         # just use the reference - and Story.build() will render much faster.
         # print "image cache used"
      if new_flowable and new_cache:
         # do not make two caches of the same filename!
         self.Images[picture_filename] = {"picture": picture,"width": tempdict["width"], "height": tempdict["height"]}
      if return_not_add:
         return picture
      else:
         self.Story.append(picture)

   def mapUnits(self,s):
        """Maps "cm" and "inch" to Reportlab-Units. TODO: Very primitive."""
        try:
             return float(string.replace(s,"cm","")) * cm
        except:
             return float(string.replace(s,"inch","")) * inch
        

   def addParagraph(self,text,stylename,bullet="",orderedList=1,return_not_add=0):
      """Add a paragraph to the Platypus-"Story". It can be (formatted) text, a bulleted list or an ordered list.
      Use return_not_add=1 for just getting the Paragraph object, without adding it to the story."""
      try:
         stylename = string.replace(stylename,"Heading ","Heading")
         # A way for very simple headings
         tempstyle = copy.copy(self.doc.stylesheet[stylename]) # beware of reference-only "copies"...
      except:
         stylename = "Normal"
         tempstyle = copy.copy(self.doc.stylesheet[stylename])          
      temptext = copy.copy(text)
      for a in self.markups.keys():
         try:
            if self.doc.stylesheet_info[stylename][a]:
               # TODO: change the workaround?
               # TODO: mind the distancePoint is always white.
               temptext = """%s%s%s%s""" % (self.markups[a][0],temptext,self.markups[a][1],self.distancePoint())
               #temptext = """%s%s<font color="white">.</font>%s""" % (self.markups[a][0],temptext,self.markups[a][1])
               # the underline <u> - tag may not enclose a whole paragraph (a reportlab bug). Workaround: insert a white token.
         except:
            # when no stylesheet_info was generated
            pass
      ##try:
##         if self.doc.stylesheet_info[stylename]["pageBreak"]:
##            self.Story.append(PageBreak())
##      except:
##         pass
      if bullet:
         tempstyle.leftIndent = 15
         tempstyle.bulletIndent = 0
         tempstyle.bulletFontSize = tempstyle.fontSize
         if not orderedList:
            # need to change the bulletFontName last!
            tempstyle.bulletFontName = "Symbol"
            bullet = "\267"
         if return_not_add:
            return Paragraph(temptext,tempstyle,bullet) # used for tables etc.
         else:
            self.Story.append(Paragraph(temptext,tempstyle,bullet))
      else:
         if return_not_add:
            return Paragraph(temptext,tempstyle)
         else:
            self.Story.append(Paragraph(temptext,tempstyle))

   def addEmptyParagraph(self,stylename,return_not_add=0):
      text = self.distancePoint()
      try:
         tempstyle = self.doc.stylesheet[stylename]
      except:
         tempstyle = self.doc.stylesheet["Normal"]
      if return_not_add:
         return Paragraph(text,tempstyle)
      else:
         self.Story.append(Paragraph(text,tempstyle))

   def testTable(self):
      """A test function for Platypus tables."""
      data = [["1","2","3"],
              ["1","2","3"],
              ["1","2","3"]]
      tempstyle = [("GRID",(0,0),(-1,-1),0.5,colors.black),
                   ("ALIGN",(0,0),(-1,-1),"LEFT")]
      #table = Table(data,colWidths=3*[3*cm],style=tempstyle)
      table = Table(data,style=tempstyle)
      table.hAlign = "LEFT"
      self.Story = [table] + self.Story

   def mapTableStyle(self):
      """Not implemented yet.
      TODO: oo has a different method when a table contains columns of the same width!
      table:table-columns ... table:number-columns-repeated="5"/> etc."""
      pass

   def buildStory(self):
      self.doc.build(self.Story)
          

class oo2pdfHandler(xml.sax.handler.ContentHandler):
    """Specialized handler for the sax parser.
    TODO: Page numbering, better table formatting..."""

    def __init__(self,infile="test.sxw",outfile=None):
       self.infile = infile
       self.outfile = ""
       if outfile is None:
          self.outfile = self.infile[:-3]+"pdf"
       self.oo2pdf = oo2pdf(self.outfile,LANDSCAPE=self.testLandscape())
       # Flags for the saxparser:
       self.inParagraph = 0
       self.inIntraParagraphMarkup = 0
       self.inTable = 0
       self.inColumn = 0
       self.inHeaderRows = 0
       self.inRow = 0
       self.inCell = 0
       self.inStyle = 0
       self.inParagraphStyle = 0
       self.inTextStyle = 0
       self.inTableCellStyle = 0
       self.inUnorderedList = 0
       self.inOrderedList = 0
       self.orderedListCounter = 0
       self.inListItem = 0
       self.inDropIt = 0
       self.imageAdded = 0
       self.emptyParagraph = 0
       self.tabStop = 0
       self.text = ""
       #self.tableText = ""
       self.currentStylename = ""
       self.currentParagraphStyle = ""
       self.currentTableStyle = ""
       self.currentTextStyle = ""
       self.currentParagraphText = ""
       self.currentListItemText = ""
       self.currentTableContent = []
       self.currentRowContent = []
       self.currentCellContent = []
       self.currentPictureAttrs = {}
       self.pictureFiles = {}
       xml.sax.handler.ContentHandler.__init__(self)

    def  readContent(self,file="content.xml"):
       """read content-xml from the sxw-zip-archive"""
       z = zipfile.ZipFile(self.infile,"r")
       content = z.read(file)
       z.close()
       return content

    def testLandscape(self):
       """Test the styles.xml for landscape. TODO: very primitive."""
       styles = self.readContent(file="styles.xml")
       if styles.find("style:print-orientation=\"landscape\"") != -1:
            return 1
       else:
            return 0

    def readPicture(self,picture):
       """read a picture from Pictures/ in the sxw-zip-archive."""
       z = zipfile.ZipFile(self.infile,"r")
       try:
          content = z.read("Pictures/" + picture)
          z.close()
          return content
       except:
          z.close()
          return None

    def setTableBorder(self,attrs):
       """If at last one table cell of the oo-table has a border, in pdf the whole table is printed with a grid.
       TODO: Too primitive?"""
       for a in attrs.keys():
          a = a.encode("latin-1")
          if string.find(a,"fo:border") != -1:
             if (attrs[a].encode("latin-1")).lower() != "none":
                # use "Table1" from "Table1.A1" etc.
                self.oo2pdf.doc.tablestyle_border[self.currentTableStyle] = 1

    def startElement(self,name,attrs):
        """Custom style function for the "startElement"-event.
        Transform unicode always to latin-1 - do not use it for Asian fonts etc."""
        # TODO:
        if 1:
            if name == "text:h":
               # TODO: Do not handle headings always like paragraphs.
               # This is a workaround - otherwise you get into trouble with the "underline"-Attribute.
               name = "text:p"
            if name == "text:p":
                self.currentParagraphStyle = attrs.get("text:style-name","Normal").encode("latin-1")
                # TODO: what about empty paragraph-tags = newline like <text:p ......... />?                
                try:
                   if self.oo2pdf.doc.stylesheet_info[self.currentParagraphStyle]["pageBreak"]:
                      self.oo2pdf.Story.append(PageBreak())
                except:
                   pass
                self.inParagraph = 1
                self.emptyParagraph = 1
                temp = attrs.get("text:level")
                if temp in ("1","2","3"):
                   self.currentParagraphStyle = "Heading" + temp
                   # TODO: very primitive...
                self.currentParagraphText = ""
                # TODO:
                #if self.inListItem:
                #   print "style-beginn: ",self.currentParagraphStyle
            elif name == "text:span":
               self.currentTextStyle = attrs.get("text:style-name","Normal").encode("latin-1")
               self.inIntraParagraphMarkup = 1
            elif name == "table:table":
                self.inTable = 1
                self.currentTableContent = []
                self.currentTableStyle = attrs.get("table:style-name").encode("latin-1")
            elif name == "table:table-column":
                 self.inColumn = 1
                 # TODO: to be implemented
            elif name == "table:table-header-rows":
                 self.inHeaderRows = 1
                 # TODO: to be implemented
            elif name == "table:table-row":
                self.inRow = 1
                self.currentRowContent = []
            elif name == "table:table-cell":
                self.currentCellContent = []
                self.inCell = 1
            elif name == "text:unordered-list":
               self.inUnorderedList = 1
            elif name == "text:ordered-list":
               self.inOrderedList = 1
            elif name == "text:list-item":
               self.inListItem = 1
               self.currentListItemText = ""
               if self.inOrderedList:
                  self.orderedListCounter += 1
            elif name == "text:tab-stop":
               self.tabStop = 1
            elif name == "style:style":
                # TODO: What about the table-styles?
                self.inStyle = 1
                if attrs.get("style:family") == "paragraph":
                   self.inParagraphStyle = 1
                   self.currentStylename = attrs.get("style:name").encode("latin-1")
                if attrs.get("style:family") == "text":
                   self.inTextStyle = 1
                   self.currentStylename = attrs.get("style:name").encode("latin-1")
                if attrs.get("style:family") == "table":
                   tempname = attrs.get("style:name").encode("latin-1")
                   self.oo2pdf.doc.tablestyle_border[tempname] = 0
                   # table without border as default
                if attrs.get("style:family") == "table-cell":
                   self.inTableCellStyle = 1
                   self.currentTableStyle =  ((attrs.get("style:name"," . ")).encode("latin-1")).split(".")[0]
            elif name == "style:properties" and self.inStyle:
               if self.inParagraphStyle:
                  self.handleParagraphStyle(attrs)
               if self.inTextStyle:
                  self.handleTextStyle(attrs)
               if self.inTableCellStyle:
                  self.setTableBorder(attrs)
            elif name == "draw:image":
               self.currentPictureAttrs = attrs
               #self.emptyParagraph = 0
            else:
               # unrecognized events:
               self.inDropIt = 1
               # TODO: cancel the following test:
               self.currentParagraphText += ("<" + name + ">").encode("Latin-1")
        else:
            # print "exception"
            pass

    def handleParagraphStyle(self,attrs):
       styledict = self.oo2pdf.mapParagraphStyle(attrs)
       self.oo2pdf.addParagraphStyle(self.currentStylename,styledict)

    def handlePicture(self,attrs):
       try:
          filename = string.replace(attrs.get("xlink:href",""),"""#Pictures/""","")
       except:
          return 0
       content = self.readPicture(filename)
       self.pictureFiles[filename] = ""
       if self.inCell:
          if SKIP["images"]:
             self.currentCellContent.append(self.oo2pdf.addParagraph("""###pictures unprocessable###""","Heading1",return_not_add=1))
          else:
             self.currentCellContent.append(self.oo2pdf.addPicture(attrs,filename,content,return_not_add=1))
       else:
          if SKIP["images"]:
             self.oo2pdf.addParagraph("""###pictures unprocessable###""","Heading1")
          else:
             self.oo2pdf.addPicture(attrs,filename,content)
       return 1

    def handleTextStyle(self,attrs):
       self.oo2pdf.addTextStyle(self.currentStylename,attrs)

    def conditionalEscape(self,text):
       """Special escape for XML-Style-Markups in Platypus."""
       if self.inIntraParagraphMarkup:
          return self.oo2pdf.doc.textMarkupStyles.get(self.currentTextStyle,"""%s""") % escape(text)
       else:
          return escape(text)

    def endElement(self,name):
        """Custom-style endElement-Events. The events are used to build up the Platypus-"Story"."""
        # TODO: use try-except.
        if 1:
            ########## Handling the OO-Paragraphs (they are found almost everywhere in an OO-Document. ########
            if name == "text:h":
               name = "text:p"
            if name == "text:p":
                self.inParagraph = 0
                # TODO: tables!
                #if not self.inTable and not self.inOrderedList and not self.inUnorderedList:
                if not self.inOrderedList and not self.inUnorderedList:
                   # Normal paragraphs or paragraphs inside of tables:
                   if self.emptyParagraph:
                      if not self.inCell:
                         self.oo2pdf.addEmptyParagraph(self.currentParagraphStyle)
                      else:
                         if not self.imageAdded:
                            self.currentCellContent.append(self.oo2pdf.addEmptyParagraph(self.currentParagraphStyle,return_not_add=1))                         
                   else:
                      if not self.inCell:
                         self.oo2pdf.addParagraph(self.currentParagraphText,self.currentParagraphStyle)
                      else:
                         # you need a list of flowables (I don't no why), so you can't append only (' ').
                         self.currentCellContent.append(self.oo2pdf.addParagraph(self.currentParagraphText,self.currentParagraphStyle,return_not_add=1))
                elif self.inListItem:
                   # Paragraphs inside of lists.
                   if self.inOrderedList:
                      self.oo2pdf.addParagraph(self.currentListItemText,self.currentParagraphStyle,bullet="%s." % self.orderedListCounter,orderedList=1)
                   elif self.inUnorderedList:
                      self.oo2pdf.addParagraph(self.currentListItemText,self.currentParagraphStyle,bullet=".",orderedList=0)
                      
                                 
                #print "style-end: ",self.currentParagraphStyle,"\n"
                self.currentParagraphStyle = ""
                self.currentParagraphText = ""
                self.imageAdded = 0
                #if not self.inTable:
                #    self.text += "\n"
            elif name == "draw:image":
               # TODO: tables? or in handlePicture?
               self.imageAdded = self.handlePicture(self.currentPictureAttrs)
               self.currentPictureAttrs = {}
            elif name == "text:span":
               self.inIntraParagraphMarkup = 0
               self.currentTextStyle = ""
            elif name == "table:table":
                self.inTable = 0
                self.oo2pdf.addTable(self.currentTableContent,self.currentTableStyle)
                self.currentTableStyle = ""
            elif name == "table:table-row":
                self.inRow = 0
                self.currentTableContent.append(self.currentRowContent)
                # print self.currentRowContent
            elif name == "table:table-cell":
                if len(self.currentCellContent) > 1:
                   self.currentRowContent.append(self.currentCellContent)
                else:
                   self.currentRowContent.append(self.currentCellContent[0])
                   # Platypus cannot handle lists with a single element as table cell elements.
                self.inCell = 0
            elif name == "text:unordered-list":
               self.inUnorderedList = 0
               self.currentListItemText = ""
            elif name == "text:ordered-list":
               self.inOrderedList = 0
               self.orderedListCounter = 0
               self.currentListItemText = ""
            elif name == "text:list-item":
               self.inListItem = 0
               self.currentListItemText = ""
            elif name == "table:table-column":
                 self.inColumn = 0
                 # TODO: to be implemented
            elif name == "table:table-header-rows":
                 self.inHeaderRows = 0
                 # TODO: to be implemented
            elif name == "style:style":
                self.inStyle = 0
                self.inParagraphStyle = 0
                self.inTextStyle = 0
                self.currentStylename = ""
                self.inTableCellStyle = 0
            else:
               self.inDropIt = 0
               # TODO: cancel the following test:
               # self.currentParagraphText += ("""</""" + name + ">").encode("Latin-1")
        else:
            pass

    def characters(self,characters):
       if self.inDropIt:
          return
       try:
          characters = characters.encode("cp1252","replace")  
          #characters = characters.encode("latin-1","replace")
       except:
          # skip "strange" unicode-characters etc.
          # TODO
          tempchar = ""
          for j in characters:
             try:
                tempchar += j.encode("cp1252")
             except:
                pass
          characters = tempchar
       tempTab = ""
       if self.tabStop:
          tempTab = self.oo2pdf.distancePoint(length=15)
          # TODO: very primitive and always white.
          self.tabStop = 0
       #if self.inIntraParagraphMarkup:
       #   characters = self.oo2pdf.doc.textMarkupStyles.get(self.currentTextStyle,"""%s""") % characters
       #characters = """%s<u>test</u>endetest""" % characters
       #characters = """<i>%s</i>""" % characters
       # TODO: handle tables properly o.k.?
       #if self.inParagraph and not self.inTable and not self.inOrderedList and not self.inUnorderedList:
       if self.inParagraph and not self.inOrderedList and not self.inUnorderedList:
          #self.text += characters
          self.currentParagraphText += tempTab + self.conditionalEscape(characters)
          #print self.currentParagraphStyle,": ",characters,"\n"
          self.emptyParagraph = 0
          return
       if self.inOrderedList and self.inListItem and self.inParagraph:
          #print "ordered-list: ",characters,"\n"
          self.currentListItemText += tempTab + self.conditionalEscape(characters)
          # print "Ordered style: ", self.currentParagraphStyle
          return
       if self.inUnorderedList and self.inListItem and self.inParagraph:
          #print "unordered-list"
          self.currentListItemText += tempTab + self.conditionalEscape(characters)
          return
       else:
          pass
          # TODO: add the characters
          characters = string.strip(characters)
          # drop all spaces, returns etc. for sxw-files stored without "pretty-printing".
          if characters != "":
             self.oo2pdf.addParagraph(self.conditionalEscape(characters),"Normal")
          #print "Normal: ",characters
          return

class ooTextHandler(oo2pdfHandler):
     """Extract the plain text from a sxw-file. Inserts one carriage-return per sxw-paragraph."""
     def __init__(self,infile="test.sxw",outfile=None,plain_text_output=0):
          oo2pdfHandler.__init__(self,infile=infile,outfile=outfile)
          self.text = ""
          self.plain_text_output = plain_text_output # return as plain latin-1 text?

     def startElement(self,name,attrs):
          pass

     def endElement(self,name):
          if name == "text:p":
               self.text += "\n"

     def characters(self,characters):
          self.text += characters.encode("cp1252","replace")

     def makeParagraphs(self):
          list = self.text.split("\n")
          for l in list:
               self.oo2pdf.addParagraph(l,"Normal")

     def endDocument(self):
          if not self.plain_text_output:
               self.makeParagraphs()
          else:
               self.outfile = self.outfile[:-3] + "txt" # "txt" instead of "pdf"
               tempfile = open(self.outfile,"w")
               tempfile.write(string.strip(self.text))
               tempfile.close()               

class PyOpenOffice:
   """This is the main class which provides all functionality."""
   global VERBOSE

   def __init__(self,v=1):
      VERBOSE = v
      self.text_tool = Textutilities()

   def makePdf(self,infile="test.sxw",outfile=None,plainText=0,plain_text_output=0):
      # print "infile: ",infile
      if plainText:
           handler = ooTextHandler(infile,outfile,plain_text_output=plain_text_output)
      else:
           handler = oo2pdfHandler(infile,outfile)
      saxparser = xml.sax.make_parser()
      saxparser.setContentHandler(handler)
      # write two files into the current working directory for the parser:
      contentfile_name = os.path.join(os.getcwd(),"content.xml")
      dummydtd_name = os.path.join(os.getcwd(),"office.dtd") # required by the sax-parser 
      contentfile = open(contentfile_name,"wb")
      # TODO: encoding here?
      content = handler.readContent()
      contentfile.write(content)
      contentfile.close()
      dummy_dtd = open(dummydtd_name,"w")
      dummy_dtd.write("nothing")
      dummy_dtd.close()
      saxparser.parse(contentfile_name)
      #text = handler.text.encode("latin-1")
      # TODO: do not use hardcoded encoding
      if VERBOSE:
         print "parsing done!"
      if not plain_text_output:
           handler.oo2pdf.buildStory()
      try:
           os.remove(contentfile_name)
           os.remove(dummydtd_name) # house cleaning...
      except:
           pass # for problems with access rights
      for file in handler.pictureFiles.keys():
         try:
            os.remove(file)
         except:
            # file not found etc.
            pass
      # TODO: remove this test-tool:
      #os.remove(handler.oo2pdf.filename)
      # os.system("""acroread %s&""" % handler.oo2pdf.filename)
      return handler.outfile

   def makeSafePdf(self,oowriter):
      """Make PDFs from a list of sxw-files or a single file. Make several trials, when an error occurs:
      full featured, without underlines, without images, text only without all formatting as a last rescue."""
      if oowriter is not types.ListType or oowriter is not types.TupleType:
           oowriter = ["%s" % oowriter] # only one file
      outfiles = []
      for i in oowriter:
          try:
             outfiles.append(self.makePdf(i))
          except:
             #print "no underlines"
             SKIP["underline"] = 1
             try:
                outfiles.append(self.makePdf(i))
             except:
                #print "no images"
                SKIP["images"] = 1
                try:
                     outfiles.append(self.makePdf(i))
                except:
                     outfiles.append(self.makePlainText(i))
          SKIP["underline"], SKIP["images"] = 0,0
      return outfiles

   def makePlainText(self,oowriter,plain_text_output=0):
        """Makes PDFs or plain text files from sxw files. All XML-Tags for formatting are dropped,
        no images are processed, table cells are transformed to paragraphs with text data.
        Output: pdf or plain text (plain_text_output=1)."""
        outfiles = []
        if oowriter is not types.ListType or oowriter is not types.TupleType:
           oowriter = ["%s" % oowriter] # only one file
        for i in oowriter:
             outfiles.append(self.makePdf(infile=i,plainText=1,plain_text_output=plain_text_output))
        return outfiles

   def makeSerialLetters(self,sourcefile,replace_listofdicts,one_file=1):
      """Make Serial letters from the records in replace_listofdicts. If one_file=1, the output is merged to one file.
      Output: sxw."""
      newcontent = self.text_tool.openOfficeMultiReplace(sourcefile=sourcefile,replace_listofdicts=replace_listofdicts,as_file=0)
      return self.text_tool.openOfficeSerialLetter(sourcefile=sourcefile,replace_listofdicts=replace_listofdicts,one_file=one_file,content=newcontent)

   def replacePictures(self,sourcefile,pic_list):
      return self.text_tool.openOfficeReplacePictures(file=sourcefile,pic_list=pic_list) 


##testlist = [{"Surname": "Simon", "FirstName": "Martin", "Postcode": "08309", "City": "Eibenstock"},
##            {"Surname": "Miller", "FirstName": "Steve", "Postcode": "12345", "City": "Nowhere-City"},
##            {"Surname": "Smith", "FirstName": "John", "Postcode": "54321", "City": "Everywhere"}]


lod = [{"Book": "Holy Bible, Luther Version", "Price": "15.00"},
       {"Book": "Calendar for Daily Devotion", "Price": "8.00"},
       {"Book": "Holy Bible, Good News Version", "Price": "17.00"},
       {"Surname": "Simon", "FirstName": "Martin"},
       {"Surname": "Miller","FirstName": "Steve"},
       {"Surname": "Smith", "FirstName": "John"},
       {"StrangeField": "StrangeValue"}]


pictest = [{"Headline": "Useful Bible Study","Pic1": "Pray","Pic2": "Read","Pic3": "Think","Pic4": "Pray again","Pic5": "Practice it!","Pic6": "You see: The place is left empty."}]

piclist = ["pray1.pcx","read.pcx","think.pcx","pray2.pcx","act.pcx"]          
          
         
 
if __name__ == "__main__":
   # TODO: remove test
   try:
      infile = [sys.argv[1]]
   except:
      infile = ["test.sxw"]
   tool = PyOpenOffice()
   newfile = ""
   if infile[0] == "-pictest": 
        newfile = tool.replacePictures("test_pic.sxw",piclist)
        #newfile = "test_pic.sxw"
        newfile = tool.makeSerialLetters(newfile,pictest)
        #print newfile
   else:
        newfile = tool.makeSerialLetters(infile[0],lod)
   tool.makeSafePdf(newfile)
   #tool.makePlainText(infile[0],plain_text_output=1)

